-------------------------------------------------
--file automatically generated

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

library work;
use work.testimage.ALL;
use work.maskdata.ALL;
use work.referencedata.ALL;

--Top Module: 
ENTITY Houghtransform IS
	PORT(
		clk : in std_logic;
		reset : in std_logic;
		enable : in std_logic;
		pixIn : in std_logic_vector(0 downto 0);
		--pixOut : out std_logic_vector(RefBitwidth - 1 downto 0) --Bit size generated from valid pixels in mask
		pixOut : out unsigned(RefBitwidth - 1 downto 0)
	);
END ENTITY Houghtransform;

ARCHITECTURE behavioral OF Houghtransform IS 

CONSTANT DPL: natural := (MaskHeight - 1) * ImageWidth + MaskWidth;	--Generated, is ((maskheight-1) * imagewidth) + maskwidth + 1
TYPE DelayPipelineType IS ARRAY (natural range 0 to DPL - 1) OF std_logic_vector(0 downto 0);

CONSTANT padding : unsigned(RefBitwidth - 2 downto 0) := (others => '0');

SIGNAL delayPipeline, delayPipeline_next : DelayPipelineType;
--signal pixOut_sig, pixOut_sig_next : std_logic_vector(RefBitwidth - 1 downto 0);
signal pixOut_sig, pixOut_sig_next : unsigned(RefBitwidth - 1 downto 0);

BEGIN
Clocked_Proc : PROCESS(clk,reset)
BEGIN
	IF (reset = '1') THEN
		delayPipeline(0 TO DPL - 1) <= (others => (others => '0'));
		pixOut <= (OTHERS => '0');
		--pixOut_sig <= (others => '0');
	ELSIF (clk'event AND clk = '1') THEN
		IF (enable = '1') THEN
			--pixOut <= std_logic_vector(delayPipeline(0));
			--delayPipeline(0 TO DPL - 2) <= delayPipeline_next(1 TO DPL - 1);
			delayPipeline <= delayPipeline_next;
		--	pixOut_sig <= pixOut_sig_next;
			pixOut <= pixOut_sig;
			
		END IF;
	END IF; 
END PROCESS Clocked_Proc;

Comb_Proc_calc : PROCESS(delayPipeline, pixIn)
variable sum : unsigned(RefBitwidth-1 downto 0) := (others => '0');
BEGIN
	delayPipeline_next(0 TO DPL - 2) <= delayPipeline(1 TO DPL - 1);	--REgister
	delayPipeline_next(DPL - 1) <= pixIn;
	sum := (OTHERS => '0');
	
	FOR y in 0 to (MaskHeight - 1) LOOP
		FOR x in 0 to (MaskWidth - 1) LOOP
			IF (Mask(y,x) = '1') THEN
      			--sum := sum + (padding & unsigned(delayPipeline(x + (y * ImageWidth))));
					--sum := sum + ('0' & '0' & unsigned(delayPipeline(x + (y * ImageWidth))));
					sum := sum + unsigned(delayPipeline(x + (y * ImageWidth)));
			END IF;
		END LOOP;
	END LOOP;
	
	pixOut_sig <= sum;
	
END PROCESS Comb_Proc_calc;

END behavioral;