----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:46:49 08/24/2011 
-- Design Name: 
-- Module Name:    topHT - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: Fungiert als Topmodul fr die beiden Module Houghtransformation und Peaksuche. Synthetisiert mit zwei unerklrlichen 
-- Warnungen: Fehlende Signale in der Sensitivity-Liste von serIn (obwohl sie eigentlich drin sind) und nicht benutzte Signale, obwohl sie als Variable genutzt werden (Schreibend und Lesend)
-- Post-Synthese-Simulation stimmt mit funktionaler Simulation berein. 
-- Post-Translate-Simulation erzeugt falsche Ergebnisse 
-- Post-Map-Simulation erzeugt falsche Ergebnisse 
-- Post-Place&Route-Simulation erzeugt falsche Ergebnisse 
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

library work;
use work.testbild.ALL;
use work.shape_data.ALL;
use work.referenceData.all; 

entity topHT is
    Port ( 	
		clk : in  STD_LOGIC;
		reset : in  STD_LOGIC;
		enable_ht : in  STD_LOGIC;
		enable_pd : in  STD_LOGIC;
		--hough_space_out : out hough_array;
		serialIn : in  STD_LOGIC;
		peak_found : out  STD_LOGIC;
		found_y : out std_logic_vector(3 downto 0);
		found_x : out std_logic_vector(3 downto 0)
	);
end topHT;

architecture Behavioral of topHT is

component serIn
	port(
		clk : in std_logic;
		reset : in std_logic;
		serialIn : in std_logic;
		--hough_space : out std_logic_vector3(0 to 7, 0 to 7, 2 downto 0);	--For PAR-Simulation
		hough_space : out hough_array;
		enable : in std_logic
	);
end component;

component peakDetector
	port(
		clk : in std_logic;
		reset : in std_logic;
		enable : in std_logic;
		hough_space : in hough_array;
		peak_found : out std_logic;
		found_y : out std_logic_vector(3 downto 0);
		found_x : out std_logic_vector(3 downto 0)
	);
end component;

--Signal for inter module communication
--signal hough_space_sig : std_logic_vector3(0 to 7, 0 to 7, 2 downto 0);
signal hough_space_sig : hough_array;

begin

ht : serIn PORT MAP (
	clk => clk,
	reset => reset,
	serialIn => serialIn,
	hough_space => hough_space_sig,
	enable => enable_ht
);

pd : peakDetector PORT MAP (
	clk => clk,
	reset => reset,
	enable => enable_pd,
	hough_space => hough_space_sig,
	peak_found => peak_found,
	found_y => found_y,
	found_x => found_x
);

	--Output Port of Top Module:
	--hough_space_out <= hough_space_sig;

end Behavioral;

